/* FONTINST.CMD for compatibility fonts */

x = setlocal()

echo = '@'

i = 1
typ.i = CODEDFONTS;    typreq.i = NO; i = i + 1
typ.i = COMPAT240;     typreq.i = NO; i = i + 1
typ.i = COMPAT300;     typreq.i = NO; i = i + 1
typ.i = ALL;           typreq.i = NO
tottypes = i

source = '.'

ARG commandline

if WORDS(commandline) <> 0 then do
  if WORDS(commandline) < 2 then do
    targetdrv = WORD(commandline, 1)
    fontset.1 = ALL
    totfont = 1
  end
  else do
    if WORDS(commandline) < 7 then do
      targetdrv = WORD(commandline, 1)
      do i = 2 to WORDS(commandline)
        if WORDS(commandline) >= i then do
          j = i - 1
          fontset.j = WORD(commandline, i)
        end
      end
      totfont = WORDS(commandline) - 1
    end
    else do
      CALL HELP;
    end
  end
end
else do
  CALL HELP;
end

if POS(':', targetdrv) <> 2 then do
  CALL HELP;
end
drvlet = SUBSTR(targetdrv, 1, 1)
if POS(drvlet, 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz') = 0 then do
  CALL HELP;
end
if LENGTH(targetdrv) <> 2 then do
  CALL HELP;
end

targetdir = targetdrv || '\PSF2RES'

say '*********************************************************'
say '* Assurez-vous que l''espace disque disponible est'
say '* suffisant avant d''installer les polices PSF/2.'
say '* Appuyez sur <Entre> pour continuer ou sur <Ctl-C> pour'
say '* mettre fin  l''installation des polices de PSF/2. Une fois'
say '* l''installation lance, vous pourrez avoir  appuyer plusieurs'
say '* fois sur <Ctl-C> pour y mettre fin.'
say '*********************************************************'
parse upper pull dummy

echo || 'md 'targetdir

if rc <> 0 then do
  call RxFuncAdd 'SysMkDir', 'RexxUtil', 'SysMkDir'
  ret_code = SysMkDir(targetdir)
  if ret_code <> 5 then do
    EXIT;
  end
end

do i = 1 to totfont
  matchfound = NO
  do j = 1 by 1 while SYMBOL('typ.j') = 'VAR'
    if fontset.i = typ.j then do
      matchfound = YES
      typreq.j = YES
      leave
    end
  end
  if matchfound = NO then do
    CALL HELP;
  end
end

say '*******************************************************************'
say '* Installation des fichiers de polices PSF/2 2.00 dans le'
say '* rpertoire cible. Si un rpertoire existe mais si les fichiers'
say '* sont introuvables, des messages d''erreur apparaissent. N''en'
say '* tenez pas compte. Appuyez sur <Ctl-C> pour arrter l''opration.'
say '* Vous pourrez avoir  appuyer sur <Ctl-C> avant la fin de'
say '* l''installation.'
say '*******************************************************************'

echo || 'md 'targetdir'\FONTC240'
echo || 'md 'targetdir'\FONTC300'
echo || 'md 'targetdir'\CODEFONT'
echo || 'md 'targetdir'\CODEPAGE'
echo || 'md 'targetdir'\CODEPAGE\PRIMARY'
echo || 'md 'targetdir'\CODEPAGE\SECONDRY'

echo || 'attrib -r 'targetdir'\*.* /s'
if rc <> 0 then do
  if rc <> 2 then do
    EXIT;
  end
end

font240d = NO
font300d = NO
codefontd = NO
codepaged = NO
do i = 1 to tottypes
  if typreq.i = YES then do
    select
      when typ.i = CODEDFONTS then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        codefontd = YES
      end
      when typ.i = COMPAT240 then do
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        codepaged = YES
      end
      when typ.i = COMPAT300 then do
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font300d = YES
        codepaged = YES
      end
      when typ.i = ALL then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        font300d = YES
        codefontd = YES
        codepaged = YES
      end
      otherwise
        say 'Programme dfectueux, contactez le responsable PSF/2.'
    end
  end
end

targetdrv
echo || 'cd 'targetdir

say '*********************************************************'
say '* Ajout des polices PSF/2 2.0   la Bibliothque de Ressources.'
say '* Appuyez sur <Ctl-C> pour y mettre fin.'
say '*********************************************************'

if font240d = YES then do
  echo || 'cd .\FONTC240'
  echo || 'RLADD R *.* * /R /L > ..\FONT240.LOG'
  echo || 'cd ..'
end

if font300d = YES then do
  echo || 'cd .\FONTC300'
  echo || 'RLADD R *.* * /R /L > ..\FONT300.LOG'
  echo || 'cd ..'
end

if codefontd = YES then do
  echo || 'cd .\CODEFONT'
  echo || 'RLADD R *.* * /R /L > ..\FONTCF.LOG'
  echo || 'cd ..'
end

if codepaged = YES then do
  echo || 'cd .\CODEPAGE\PRIMARY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTPRI.LOG'
  echo || 'cd ..\SECONDRY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTSEC.LOG'
  echo || 'cd ..\..'
end

say '*********************************************************'
say '* Des polices ont t ajoutes. Pour plus de dtails,'
say '* vrifiez les fichiers 'targetdir'\FONT*.LOG.'
say '*********************************************************'

x = endlocal()
CALL QUIT;

HELP:;
  say '**************************************************************';
  say '* Cette commande doit tre lance  partir du rpertoire     *';
  say '* dans lequel se trouvent les fichiers d''installation       *';
  say '* de PSF/2.                                                  *';
  say '*                                                            *';
  say '* Cette commande d''installation requiert un paramtre.      *';
  say '*                                                            *';
  say '* La syntaxe est la suivante :                               *';
  say '*   FONTINST <unit cible> <polices>                         *';
  say '*                                                            *';
  say '* o :                                                       *';
  say '*   <unit cible> est l''unit d''installation de PSF/2. Il  *';
  say '*     ne s''agit pas de l''unit sur laquelle les fichiers   *';
  say '*     PSF/2 ont t temporairement enregistrs aprs la      *';
  say '*     commande PUTDIR.                                       *';
  say '*     Ce paramtre est obligatoire.                          *';
  say '*   <polices> correspond  un ou  la totalit des           *';
  say '*     lments suivants :                                    *';
  say '*     ALL (par dfaut)                                       *';
  say '*     CODEDFONTS                                             *';
  say '*     COMPAT240                                              *';
  say '*     COMPAT300                                              *';
  say '* Exemple :                                                  *';
  say '*   fontinst c: all                                          *';
  say '*                                                            *';
  say '* Les polices sont installes dans le rpertoire \PSF2RES ;  *';
  say '* toutes les autres polices situes dans les rpertoires des *';
  say '* polices sont ajoutes  la Bibliothque de Ressources.     *';
  say '**************************************************************';
  x = endlocal()
  CALL QUIT;
RETURN;

QUIT:;
EXIT;
